import {
  Controller,
  Get,
  Res,
  HttpStatus,
  Post,
  Body,
  Put,
  NotFoundException,
  Delete,
  Param,
  Query,
  Inject,
} from '@nestjs/common';
import { ApiProperty, ApiTags } from '@nestjs/swagger';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import { {{Name}}sService } from './{{inputName}}s.service';
import { Create{{Name}}Dto, Update{{Name}}Dto } from './dto';
import { PaginationQueryDto } from '../common/dto/pagination-query.dto';

@ApiTags('{{Name}}s resource')
@Controller('{{name}}s')
export class {{Name}}sController {
  errorContext: string;
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
    private {{name}}sService: {{Name}}sService,
  ) {
    this.errorContext = '{{Name}}sModule.{{Name}}sController';
  }

  // QUERY
  @Get()
  public async getAll{{Name}}(
    @Res() res,
    @Query() paginationQuery: PaginationQueryDto,
  ) {
    try {
      this.logger.debug(`${this.errorContext}.getAll{{Name}}().begun`);
      const {{name}}s = await this.{{name}}sService.findAll(paginationQuery);
      return res.status(HttpStatus.OK).json({{name}}s);
    } catch (err) {
      const errorMessage = `${this.errorContext}.getAll{{Name}}().failed: ${err.message}`;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: `Error: {{Name}}s not listed! ${errorMessage}`,
        status: 500,
      });
    }
  }

  // READ
  @Get('/:id')
  public async get{{Name}}(@Res() res, @Param('id') {{name}}Id: string) {
    try {
      this.logger.debug(`${this.errorContext}.get{{Name}}().begun`);
      if (!{{name}}Id) {
        throw new NotFoundException('Param ID is required');
      }
      const {{name}} = await this.{{name}}sService.findOne({{name}}Id);
      if (!{{name}}) {
        throw new NotFoundException('{{Name}} does not exist!');
      }
      return res.status(HttpStatus.OK).json({{name}});
    } catch (err) {
      const errorMessage = `${this.errorContext}.get{{Name}}().failed: ${err.message}`;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: `Error: {{Name}} not read! ${errorMessage}`,
        status: 500,
      });
    }
  }

  // CREATE
  @Post()
  // @HttpCode(201) // already 201 by defaut for POST
  public async create{{Name}}(@Res() res, @Body() create{{Name}}Dto: Create{{Name}}Dto) {
    try {
      this.logger.debug(`${this.errorContext}.create{{Name}}().begun`);
      if (!create{{Name}}Dto) {
        throw new NotFoundException('Param body is required');
      }
      const {{name}} = await this.{{name}}sService.create(create{{Name}}Dto);
      return res.status(HttpStatus.CREATED).json({
        message: '{{Name}} has been created successfully',
        {{name}},
      });
    } catch (err) {
      const errorMessage = `${this.errorContext}.create{{Name}}().failed: ${err.message}`;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: `Error: {{Name}} not created! ${errorMessage}`,
        status: 500,
      });
    }
  }

  // UPDATE
  @Put('/:id')
  public async update{{Name}}(
    @Res() res,
    @Param('id') {{name}}Id: string,
    @Body() update{{Name}}Dto: Update{{Name}}Dto,
  ) {
    try {
      this.logger.debug(`${this.errorContext}.update{{Name}}().begun`);
      if (!{{name}}Id) {
        throw new NotFoundException('Param ID is required');
      }
      const {{name}} = await this.{{name}}sService.update({{name}}Id, update{{Name}}Dto);
      if (!{{name}}) {
        throw new NotFoundException('{{Name}} does not exist!');
      }
      return res.status(HttpStatus.OK).json({
        message: '{{Name}} has been successfully updated',
        {{name}},
      });
    } catch (err) {
      const errorMessage = `${this.errorContext}.update{{Name}}().failed: ${err.message}`;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: `Error: {{Name}} not updated! ${errorMessage}`,
        status: 500,
      });
    }
  }

  // DELETE
  @Delete('/:id')
  public async delete{{Name}}(@Res() res, @Param('id') {{name}}Id: string) {
    try {
      this.logger.debug(`${this.errorContext}.delete{{Name}}().begun`);
      if (!{{name}}Id) {
        throw new NotFoundException('{{Name}} ID does not exist');
      }

      const {{name}} = await this.{{name}}sService.remove({{name}}Id);

      if (!{{name}}) {
        throw new NotFoundException('{{Name}} does not exist');
      }

      return res.status(HttpStatus.OK).json({
        message: '{{Name}} has been deleted',
        {{name}},
      });
    } catch (err) {
      const errorMessage = `${this.errorContext}.delete{{Name}}().failed: ${err.message}`;
      this.logger.error(errorMessage);
      return res.status(HttpStatus.BAD_REQUEST).json({
        message: `Error: {{Name}} not deleted! ${errorMessage}`,
        status: 500,
      });
    }
  }
}
